#pragma once
#include <memory.h>
#include <multiboot.h>
#include <framebuffer.h>

#define VGA_MEMORY P2V(0xB8000)
#define VGA_COLS 80
#define VGA_ROWS 24
#define VGA_SIZE (VGA_COLS*VGA_ROWS)

struct vga_cell{
    uint8_t c;
    uint8_t f;
}__attribute__((packed));

// drivers/vga.c
extern struct vga_cell buffer[];

// drivers/vga.c
void vga_init();
void vga_write(char c);

// drivers/framebuffer.c
gfx_context *framebuffer_init(struct fbinfo *fbinfo);

// drivers/vga2fb.c
void vga2fb(struct vga_cell *buffer, gfx_context *ctx, int rows, int cols);